;GridScan 2K game for Radio-86RK, Apogey BK01, Mikrosha, Partner 01.01
;by Shiru (shiru@mail.ru) 10'10

;The game and the source code are released into public domain,
;except for MegaLZ unpacker (based on code with different license)


INVISIBLE_TIME	equ 250
STUNNED_TIME	equ 15




begin
	;ld sp,#35ff
	ld hl,strSound
	call #f818
.l0
	call ROM_KEYC
	cp #ff
	jp z,.l0
	cp 'Y'
	jp z,$+4
	xor a
	ld (sound),a

videoInit
	ld hl,CRT_MEMORY
	ld bc,78*30
	ld a,' '
	call fillBlock

	xor a			;stop DMA
	ld (DMA_CMD),a
	ld a,#40
	ld (CRT_CMD),a

	ld hl,CRT_CMD	;init CRT
	ld (hl),0
	dec l;CRT_DATA
	ld (hl),77		;text buffer width-1, normal rows
	ld (hl),29		;text buffer height-1, 0 vertical retrace rows
	ld (hl),9*16+9	;underline row and height of a character
	ld (hl),#93+64	;non-transparent attributes for Partner 01.01

	inc l
	ld (hl),#80		;set cursor position to hide it
	dec l
	ld (hl),0
	ld (hl),63

	inc l;CRT_CMD	;init DMA
	ld (hl),#27

	call waitEndFrame
	call waitEndFrame

	ld hl,DMA_CMD
	ld (hl),#80
	ld l,#04;DMA_ADR_CH2
	ld (hl),#d0
	ld (hl),#36
	inc l
	ld (hl),#23
	ld (hl),#49
	ld l,#08;DMA_CMD
	ld (hl),#a4

	init1
	call soundShut

resetGame
	ld hl,1000
	ld (topScore),hl

	ld hl,CRT_MEMORY+2*78+10
	ld de,strStats
	call putStr

titleScreen
	call clearMap

	ld hl,map+26*78+31
	ld de,strTitleBy
	call putStr

	ld hl,map+10*78+15
	ld de,strTitle
	ld a,8
.l0
	push af
	push hl
	call putStr
	pop hl
	pop af
	ld bc,78
	add hl,bc
	dec a
	jp nz,.l0

	call changeScreen

	ld bc,16*256+31
	ld d,0
.waitkey
	push bc
	push de

	call waitEndFrame

	ld hl,frameCnt
	inc (hl)
	ld a,(hl)
	ld hl,CRT_MEMORY+21*78+26
	and c
	cp b
	jp c,.l1
	ld de,strTitleStart
	call putStr
	jp .l2
.l1
	ld bc,22
	ld a,' '
	call fillBlock
.l2
	call rnd
	pop de
	pop bc

	ld a,d
	or a
	jp nz,.l3
	call ROM_KEYC
	cp #ff
	jp z,.waitkey
	ld bc,4*256+7
	ld d,32+4
	xor a
	ld (frameCnt),a
	ld hl,sfxStart
	call soundPlay
.l3
	dec d
	jp nz,.waitkey


gameStart
	ld a,1
	ld (level),a
	ld a,3
	ld (lives),a
	ld hl,0
	ld (score),hl


levelStart
	call clearMap
	ld hl,map+14*78+31
	ld de,strLevel
	call putStr
	ld a,(level)
	ld h,0
	ld l,a
	ld de,map+14*78+42
	push hl
	call putNum2
	ex de,hl
	ld a,(hl)
	ld (hl),' '
	inc hl
	ld (hl),a
	pop hl
	ld de,CRT_MEMORY+2*78+43
	call putNum2

	call changeScreen
	ld hl,sfxLevel
	call soundPlay
.l0
	call waitEndFrame
	call ROM_KEYC
	cp #ff
	jp z,.l0

	call soundShut
	call clearMap

	ld a,(level)
	add a,a
	ld b,0
	ld c,a
	ld hl,levelList-2
	add hl,bc
	ld a,(hl)
	inc hl
	ld h,(hl)
	ld l,a

	ld e,(hl)
	inc hl
	ld d,(hl)
	inc hl
	ex de,hl
	ld (playerPos),hl
	ex de,hl
	ld a,(hl)
	inc hl
	ld (mapHeight),a
	ld b,a
	ld a,(hl)
	inc hl
	ld (mapWidth),a
	ld c,a
	push hl

	xor a
	add a,b
	dec c
	jp nz,$-2

	ld (areaLevel),a
	ld hl,0
	ld b,0
	ld c,a
	ld de,0

.l1
	add hl,bc
	inc de
	ld a,h
	cp 100
	jp c,.l1

	ex de,hl
	ld (areaFract),hl

	call makeField

	ld hl,map
	ld de,mapc
	ld bc,78*30
	call copyBlock

	call changeScreen

	call makeBorders
	call makeAreaList

	ld hl,areaCnt
	ld bc,7*4
	ld a,28
	call fillBlock

	ld hl,map+78*30
.l2
	dec hl
	ld a,(hl)
	cp '+'
	jp nz,.l2
	ld de,-map
	add hl,de
	ld (.enemyPos),hl

	pop hl

	ld de,enemyList
	ld c,0
	ld b,50
.l3
	ld a,(hl)
	or a
	jp z,.l4
	ld a,a
	inc hl
	push hl
	ex de,hl
	ld (hl),b	;cnt
	inc hl
	ld (hl),a	;speed
	inc hl
.enemyPos=$+1
	ld de,0
	ld (hl),e	;coord L
	inc hl
	ld (hl),d	;coord H
	inc hl
	xor a
	ld (hl),a	;dir L
	inc hl
	ld (hl),a	;dir H
	inc hl
	ld (hl),a	;rev dir
	inc hl
	ex de,hl
	pop hl
	ld a,b
	add a,40
	ld b,a
	inc c
	jp .l3
.l4
	ld a,c
	ld (enemyCnt),a

	ld hl,0
	ld (playerDir),hl
	ld a,INVISIBLE_TIME
	ld (invisible),a

	ld (levelDone),hl
	xor a
	ld (frameCnt),a
	ld (stunCnt),a

mainLoop
	call waitEndFrame

	call checkKeyboard

	ld hl,frameCnt
	inc (hl)
	ld c,a
	ld a,(hl)
	and 3
	or a
	ld a,c

	jp nz,showPlayer

	ld hl,stunCnt
	ld a,(hl)
	or a
	jp z,playerMove
	dec a
	ld (hl),a
	jp nz,showPlayer
	ld a,(lives)
	or a
	jp z,gameOver

playerMove
	ld hl,(playerPos)
	ld de,map
	add hl,de
	ld b,h
	ld c,l
	ld a,'*'
	cp (hl)
	push bc
	push hl
	jp z,.l0
	call checkArea
	ld de,1
	call addScore
.l0
	pop hl
	pop bc
	ld (hl),'*'
	ex de,hl
	ld hl,(playerDir)
	add hl,de
	ld a,(hl)
	cp ' '
	jp z,.l1
	cp 'A'
	jp nc,.l1
	ld de,-map
	add hl,de
	ld (playerPos),hl
	ld h,b
	ld l,c
	ld a,(hl)
	ld de,CRT_MEMORY-map
	add hl,de
	ld (hl),a
.l1
	call checkHit

showPlayer
	ld hl,(playerPos)
	push hl
	ld de,map
	add hl,de
	ld c,(hl)
	pop hl
	ld de,CRT_MEMORY
	add hl,de
	ld a,(invisible)
	and 15
	cp 8
	jp nc,.l0
	ld c,'O'
.l0
	ld (hl),c

processEnemies
	ld hl,enemyFrame
	inc (hl)
	ld a,(hl)
	and 4
	ld a,5
	jp z,$+5
	ld a,18
	ld (.frame),a

	ld hl,enemyList
	ld a,(enemyCnt)
.l0
	push af
	push hl

	dec (hl)
	jp nz,.l3
	inc hl
	ld a,(hl)
	dec hl
	ld (hl),a
	inc hl
	inc hl

	push hl
	ld e,(hl)
	inc hl
	ld d,(hl)
	inc hl
	ld c,(hl)
	inc hl
	ld b,(hl)
	push de
	ld hl,map
	add hl,de
	ld a,(hl)
	ld de,CRT_MEMORY-map
	add hl,de
	ld (hl),a
	pop hl
	add hl,bc
	ld b,h
	ld c,l
	pop hl
	push hl
	ld (hl),c
	inc hl
	ld (hl),b

	ld hl,mapc
	add hl,bc
	ld a,(hl)
	pop bc
	cp '+'
	jp nz,.l3

	push bc
	push hl
	ld hl,4
	add hl,bc
	ld b,(hl)
	pop hl
.l1
	call rnd
	and 3
	cp b
	jp z,.l1
	ld c,1
	ld de,-1
	or a
	jp z,.l2
	ld c,0
	ld de,1
	cp 1
	jp z,.l2
	ld c,3
	ld de,-78
	cp 2
	jp z,.l2
	ld c,2
	ld de,78
.l2
	push hl
	add hl,de
	ld a,(hl)
	pop hl
	cp ' '
	jp z,.l1
	pop hl
	inc hl
	inc hl
	ld (hl),e
	inc hl
	ld (hl),d
	inc hl
	ld (hl),c
.l3
	pop hl
	push hl
	inc hl
	inc hl
	ld c,(hl)
	inc hl
	ld b,(hl)
	ld hl,CRT_MEMORY
	add hl,bc
.frame=$+1
	ld (hl),'#'
	pop hl
	pop af
	ld bc,7
	add hl,bc
	dec a
	jp nz,.l0

	call checkHit

showStats
	ld hl,(topScore)
	ld a,h
	cpl
	ld d,a
	ld a,l
	cpl
	ld e,a
	ld hl,(score)
	add hl,de
	jp nc,.l3
	ld hl,(score)
	ld (topScore),hl
.l3
	ld hl,(score)
	ld de,CRT_MEMORY+2*78+16
	call putNum5
	ld hl,(topScore)
	ld de,CRT_MEMORY+2*78+29
	call putNum5
	ld hl,(levelDone)
	ld l,h
	ld h,0
	ld de,CRT_MEMORY+2*78+52
	call putNum3
	ld a,(lives)
	ld h,0
	ld l,a
	ld de,CRT_MEMORY+2*78+64
	call putNum1

	ld hl,invisible
	ld a,(hl)
	or a
	jp z,$+4
	dec (hl)

	ld a,(levelDone+1)
	cp 100
	jp z,levelComplete
	jp mainLoop


gameOver
	call clearMap
	ld hl,map+14*78+30
	ld de,strGameOver
	call putStr
	call changeScreen
	ld hl,sfxGameOver
	call soundPlay
.l0
	call waitEndFrame
	call ROM_KEYC
	cp #ff
	jp z,.l0
	jp titleScreen


levelComplete
	ld hl,sfxLevelClear
	call soundPlay
	ld c,10
.l0
	push af
	ld b,8
.l1
	call waitEndFrame
	dec b
	jp nz,.l1

	ld a,(areaLevel)
	ld hl,areaOff
.l2
	push af
	push hl
	ld e,(hl)
	inc hl
	ld d,(hl)
	ex de,hl
	ld a,c
	and 1
	ld de,strAreaClear
	jp z,$+6
	ld de,strAreaClearSpace
	call putStr
	pop hl
	pop af
	inc hl
	inc hl
	dec a
	jp nz,.l2

	pop af
	dec c
	jp nz,.l0

	ld hl,level
	inc (hl)
	ld a,(hl)
	cp 11
	jp c,levelStart


gameComplete
	call clearMap
	ld hl,map+12*78+17
	ld de,strComplete1
	call putStr
	ld hl,map+15*78+13
	ld de,strComplete2
	call putStr
	call changeScreen
	ld hl,sfxGameComplete
	call soundPlay
.l0
	call waitEndFrame
	call ROM_KEYC
	cp #ff
	jp z,.l0
	ld a,1
	ld (level),a
	jp levelStart




checkHit
	ld a,(invisible)
	or a
	jp nz,.l2
	ld hl,enemyList+2
	ld a,(enemyCnt)
	ld e,a
.l0
	ld a,(playerPos)
	cp (hl)
	jp nz,.l1
	inc hl
	ld a,(playerPos+1)
	cp (hl)
	dec hl
	jp nz,.l1
	ld hl,lives
	dec (hl)
	ld a,INVISIBLE_TIME
	ld (invisible),a
	ld a,STUNNED_TIME
	ld (stunCnt),a
	push hl
	ld hl,sfxHit
	call soundPlay
	pop hl
.l1
	ld bc,7
	add hl,bc
	dec e
	jp nz,.l0
.l2
	ret


addScore
	ld hl,(score)
	add hl,de
	jp nc,.l0
	ld hl,#ffff
.l0
	ld (score),hl
	ret


checkKeyboard
	call ROM_KEYC
	ld de,-1
	cp #08
	jp z,.l0
	ld de,1
	cp #18
	jp z,.l0
	ld de,-78
	cp #19
	jp z,.l0
	ld de,78
	cp #1a
	jp z,.l0
	ret
.l0
	ld hl,(playerPos)
	add hl,de
	ld bc,map
	add hl,bc
	ld a,(hl)
	cp ' '
	ret z
	cp 'A'
	ret nc
	ex de,hl
	ld (playerDir),hl
	ret


checkArea
	push hl
	ld hl,areaCntChk
	ld bc,7*4
	ld a,c
	call fillBlock
	pop hl
	ld de,-78-1
	add hl,de
	ld b,3
.l0
	ld c,3
.l1
	ld a,(hl)
	cp 'A'
	jp c,.l3
	push hl
	ld hl,areaCntChk-'A'
	ld d,0
	ld e,a
	add hl,de
	ld a,(hl)
	or a
	jp z,.l2
	ld (hl),d
	ld hl,areaCnt-'A'
	add hl,de
	dec (hl)
	jp nz,.l2
	ld hl,areaOff-'A'*2
	add hl,de
	add hl,de
	ld e,(hl)
	inc hl
	ld d,(hl)
	ex de,hl
	ld de,strAreaClear
	call putStr
	ld de,50
	call addScore
	ld hl,(levelDone)
	ex de,hl
	ld hl,(areaFract)
	add hl,de
	ld (levelDone),hl
	ld hl,sfxArea
	call soundPlay
.l2
	pop hl
.l3
	inc hl
	dec c
	jp nz,.l1
	ld de,78-3
	add hl,de
	dec b
	jp nz,.l0
	ret


putStr
	ld a,(de)
	inc de
	or a
	ret z
	ld (hl),a
	inc hl
	jp putStr


putNum5
	ld bc,-10000
	call putNum
putNum4
	ld bc,-1000
	call putNum
putNum3
	ld bc,-100
	call putNum
putNum2
	ld bc,-10
	call putNum
putNum1
	ld a,l
	add a,'0'
	ld (de),a
	ret
putNum
	push de
	ld a,'0'-1
.l0
	inc a
	ld d,h
	ld e,l
	add hl,bc
	jp c,.l0
	ex de,hl
	pop de
	ld (de),a
	inc de
	ret


rnd				;RNG from some old article
.r1=$+1
    ld a,12
    ld d,a
.r2=$+1
    ld a,34
    ld (.r1),a
    add a,d
    ld d,a
.r3=$+1
    ld a,56
    ld (.r2),a
    add a,d
    rlca
    ld (.r3),a
    ret


makeField
	ld hl,(playerPos)
	ld bc,map
	add hl,bc
	ld a,(mapHeight)
.l0
	push af
	ld de,'-'*256+'+'
	ld a,1
	call .row
	ld de,' '*256+'!'
	ld a,5
	call .row
	pop af
	dec a
	jp nz,.l0
	ld de,'-'*256+'+'
	ld a,1

.row
	push hl
	push af
	ld a,(mapWidth)
	ld b,a
	pop af
.row0
	ld (hl),e
	inc hl
	ld c,7
.row1
	ld (hl),d
	inc hl
	dec c
	jp nz,.row1
	dec b
	jp nz,.row0
	ld (hl),e
	pop hl
	ld bc,78
	add hl,bc
	dec a
	jp nz,.row
	ret


makeAreaList
	ld hl,(playerPos)
	ld bc,CRT_MEMORY+3*78+3
	add hl,bc
	ld de,areaOff
	ld a,(mapHeight)
	ld b,a
.l0
	push hl
	ld a,(mapWidth)
	ld c,a
.l1
	ex de,hl
	ld (hl),e
	inc hl
	ld (hl),d
	inc hl
	ex de,hl
	push bc
	ld bc,8
	add hl,bc
	pop bc
	dec c
	jp nz,.l1
	pop hl
	push bc
	ld bc,78*6
	add hl,bc
	pop bc
	dec b
	jp nz,.l0
	ret

makeBorders
	ld hl,(playerPos)
	ld bc,map+1*78+1
	add hl,bc
	ld a,(mapHeight)
	ld b,a
	ld a,'A'
.l0
	push hl
	push af
	ld a,(mapWidth)
	ld c,a
	pop af
.l1
	push bc
	push hl
	ld bc,7
	call fillBlock
	ld de,78-6
	add hl,de
	ld b,3
.l3
	ld (hl),a
	ld de,6
	add hl,de
	ld (hl),a
	ld de,78-6
	add hl,de
	dec b
	jp nz,.l3
	ld bc,7
	call fillBlock
	pop hl
	pop bc
	inc a
	ld de,8
	add hl,de
	dec c
	jp nz,.l1
	pop hl
	ld de,78*6
	add hl,de
	dec b
	jp nz,.l0
	ret


clearMap
	ld hl,map
	ld bc,78*30
	ld a,' '


fillBlock
	ld (hl),a
	ld d,h
	ld e,l
	inc de
	dec bc


copyBlock
	push af
.l0
	ld a,(hl)
	ld (de),a
	inc hl
	inc de
	dec bc
	ld a,b
	or c
	jp nz,.l0
	pop af
	ret


changeScreen
	call soundShut
	ld hl,map+78*29+77
	ld a,27
.l00
	push af
	push hl
	call waitEndFrame
	ld hl,CRT_MEMORY+78*28+77
	ld de,CRT_MEMORY+78*29+77
	ld c,26
.l0
	dup 78
	ld a,(hl)
	ld (de),a
	dec hl
	dec de
	edup
	dec c
	jp nz,.l0
	pop hl
	ld de,CRT_MEMORY+3*78+77
	ld c,78
.l2
	ld a,(hl)
	ld (de),a
	dec hl
	dec de
	dec c
	jp nz,.l2
	pop af
	dec a
	jp nz,.l00
	ret


waitEndFrame
	ld a,(CRT_CMD)
	and #20
	jp z,waitEndFrame


soundUpdate
	ld a,(sound)
	or a
	ret z
	ld hl,(soundPtr)
	ld a,h
	or l
	ret z
	ld a,%00100110+((TIMER_TONE&3)<<6)
	ld (TIMER_CMD),a
	ld a,(hl)
	cp 255
	jp z,soundShut
	inc hl
	ld (TIMER_TONE),a
	ld (soundPtr),hl
	ret


soundShut
	ld a,(sound)
	or a
	ret z
	ld a,%00100000+((TIMER_TONE&3)<<6)
	ld (TIMER_CMD),a
	ld hl,0
soundPlay
	ld (soundPtr),hl
	ret


sfxStart
    db (CLK/228)>>8
    db (CLK/228)>>8
    db (CLK/288)>>8
    db (CLK/288)>>8
    db (CLK/343)>>8
    db (CLK/343)>>8
    db (CLK/457)>>8
    db (CLK/457)>>8
    db (CLK/578)>>8
    db (CLK/578)>>8
    db (CLK/687)>>8
    db (CLK/687)>>8
    db (CLK/228)>>8
    db (CLK/288)>>8
    db (CLK/343)>>8
    db (CLK/457)>>8
    db (CLK/578)>>8
    db (CLK/687)>>8
    db (CLK/228)>>8
    db (CLK/288)>>8
    db (CLK/343)>>8
    db (CLK/457)>>8
    db (CLK/578)>>8
    db (CLK/687)>>8
    db (CLK/687)>>8
    db 255

sfxArea
    db (CLK/581)>>8
    db (CLK/581)>>8
    db (CLK/1562)>>8
    db (CLK/1562)>>8
    db (CLK/1562)>>8
    db 255

sfxGameComplete
    db (CLK/523)>>8
    db (CLK/261)>>8
    db (CLK/261)>>8
    db (CLK/261)>>8
    db (CLK/261)>>8
    db (CLK/261)>>8
    db (CLK/523)>>8
    db (CLK/261)>>8
    db (CLK/261)>>8
    db (CLK/261)>>8
    db (CLK/261)>>8
    db (CLK/261)>>8
    db (CLK/523)>>8
    db (CLK/261)>>8
    db (CLK/261)>>8
    db (CLK/261)>>8
    db (CLK/261)>>8
    db (CLK/261)>>8
    db (CLK/658)>>8
    db (CLK/329)>>8
    db (CLK/329)>>8
    db (CLK/329)>>8
    db (CLK/329)>>8
    db (CLK/329)>>8
    db (CLK/329)>>8
    db (CLK/329)>>8
    db (CLK/329)>>8
    db (CLK/329)>>8
    db (CLK/329)>>8
    db (CLK/329)>>8
    db (CLK/329)>>8
    db (CLK/329)>>8
    db (CLK/329)>>8
    db (CLK/329)>>8
    db (CLK/329)>>8
    db (CLK/329)>>8
    db (CLK/658)>>8
    db (CLK/329)>>8
    db (CLK/329)>>8
    db (CLK/329)>>8
    db (CLK/329)>>8
    db (CLK/329)>>8
    db (CLK/658)>>8
    db (CLK/329)>>8
    db (CLK/329)>>8
    db (CLK/329)>>8
    db (CLK/329)>>8
    db (CLK/329)>>8
    db (CLK/658)>>8
    db (CLK/329)>>8
    db (CLK/329)>>8
    db (CLK/329)>>8
    db (CLK/329)>>8
    db (CLK/329)>>8
    db (CLK/781)>>8
    db (CLK/392)>>8
    db (CLK/392)>>8
    db (CLK/392)>>8
    db (CLK/392)>>8
    db (CLK/392)>>8
    db (CLK/392)>>8
    db (CLK/392)>>8
    db (CLK/392)>>8
    db (CLK/392)>>8
    db (CLK/392)>>8
    db (CLK/392)>>8
    db (CLK/392)>>8
    db (CLK/392)>>8
    db (CLK/392)>>8
    db (CLK/392)>>8
    db (CLK/392)>>8
    db (CLK/392)>>8
    db (CLK/781)>>8
    db (CLK/392)>>8
    db (CLK/392)>>8
    db (CLK/392)>>8
    db (CLK/392)>>8
    db (CLK/392)>>8
    db (CLK/781)>>8
    db (CLK/392)>>8
    db (CLK/392)>>8
    db (CLK/392)>>8
    db (CLK/392)>>8
    db (CLK/392)>>8
    db (CLK/781)>>8
    db (CLK/392)>>8
    db (CLK/392)>>8
    db (CLK/392)>>8
    db (CLK/392)>>8
    db (CLK/392)>>8
    db (CLK/1041)>>8
    db (CLK/523)>>8
    db (CLK/523)>>8
    db (CLK/523)>>8
    db (CLK/523)>>8
    db (CLK/523)>>8
    db (CLK/523)>>8
    db (CLK/523)>>8
    db (CLK/523)>>8
    db (CLK/523)>>8
    db (CLK/523)>>8
    db (CLK/523)>>8
    db (CLK/523)>>8
    db (CLK/523)>>8
    db (CLK/523)>>8
    db (CLK/523)>>8
    db (CLK/523)>>8
    db (CLK/523)>>8
    db (CLK/523)>>8
    db 255

sfxGameOver
    db (CLK/220)>>8
    db (CLK/110)>>8
    db (CLK/110)>>8
    db (CLK/110)>>8
    db (CLK/110)>>8
    db (CLK/110)>>8
    db (CLK/110)>>8
    db (CLK/110)>>8
    db (CLK/110)>>8
    db (CLK/110)>>8
    db (CLK/110)>>8
    db (CLK/110)>>8
    db (CLK/220)>>8
    db (CLK/110)>>8
    db (CLK/110)>>8
    db (CLK/110)>>8
    db (CLK/110)>>8
    db (CLK/110)>>8
    db (CLK/110)>>8
    db (CLK/110)>>8
    db (CLK/110)>>8
    db (CLK/110)>>8
    db (CLK/110)>>8
    db (CLK/110)>>8
    db (CLK/196)>>8
    db (CLK/98)>>8
    db (CLK/98)>>8
    db (CLK/98)>>8
    db (CLK/98)>>8
    db (CLK/98)>>8
    db (CLK/98)>>8
    db (CLK/98)>>8
    db (CLK/98)>>8
    db (CLK/98)>>8
    db (CLK/98)>>8
    db (CLK/98)>>8
    db (CLK/196)>>8
    db (CLK/98)>>8
    db (CLK/98)>>8
    db (CLK/98)>>8
    db (CLK/98)>>8
    db (CLK/98)>>8
    db (CLK/220)>>8
    db (CLK/110)>>8
    db (CLK/110)>>8
    db (CLK/110)>>8
    db (CLK/110)>>8
    db (CLK/110)>>8
    db (CLK/110)>>8
    db (CLK/110)>>8
    db (CLK/110)>>8
    db (CLK/110)>>8
    db (CLK/110)>>8
    db (CLK/110)>>8
    db (CLK/110)>>8
    db (CLK/110)>>8
    db (CLK/110)>>8
    db (CLK/110)>>8
    db (CLK/110)>>8
    db (CLK/110)>>8
    db (CLK/164)>>8
    db (CLK/82)>>8
    db (CLK/82)>>8
    db (CLK/82)>>8
    db (CLK/82)>>8
    db (CLK/82)>>8
    db (CLK/82)>>8
    db (CLK/82)>>8
    db (CLK/82)>>8
    db (CLK/82)>>8
    db (CLK/82)>>8
    db (CLK/82)>>8
    db (CLK/110)>>8
    db (CLK/54)>>8
    db (CLK/54)>>8
    db (CLK/54)>>8
    db (CLK/54)>>8
    db (CLK/54)>>8
    db (CLK/54)>>8
    db (CLK/54)>>8
    db (CLK/54)>>8
    db (CLK/54)>>8
    db (CLK/54)>>8
    db (CLK/54)>>8
    db (CLK/54)>>8
    db (CLK/54)>>8
    db (CLK/54)>>8
    db (CLK/54)>>8
    db (CLK/54)>>8
    db (CLK/54)>>8
    db (CLK/54)>>8
    db (CLK/54)>>8
    db (CLK/54)>>8
    db (CLK/54)>>8
    db (CLK/54)>>8
    db (CLK/54)>>8
    db (CLK/54)>>8
    db 255

sfxHit
    db (CLK/705)>>8
    db (CLK/471)>>8
    db (CLK/353)>>8
    db (CLK/219)>>8
    db (CLK/211)>>8
    db (CLK/705)>>8
    db (CLK/471)>>8
    db (CLK/353)>>8
    db (CLK/219)>>8
    db (CLK/211)>>8
    db (CLK/705)>>8
    db (CLK/471)>>8
    db (CLK/353)>>8
    db (CLK/219)>>8
    db (CLK/211)>>8
    db (CLK/211)>>8
    db 255

sfxLevel
    db (CLK/309)>>8
    db (CLK/265)>>8
    db (CLK/276)>>8
    db (CLK/368)>>8
    db (CLK/368)>>8
    db 255

sfxLevelClear
    db (CLK/781)>>8
    db (CLK/392)>>8
    db (CLK/392)>>8
    db (CLK/392)>>8
    db (CLK/392)>>8
    db (CLK/392)>>8
    db (CLK/781)>>8
    db (CLK/392)>>8
    db (CLK/392)>>8
    db (CLK/392)>>8
    db (CLK/392)>>8
    db (CLK/392)>>8
    db (CLK/781)>>8
    db (CLK/392)>>8
    db (CLK/392)>>8
    db (CLK/392)>>8
    db (CLK/392)>>8
    db (CLK/392)>>8
    db (CLK/1041)>>8
    db (CLK/523)>>8
    db (CLK/523)>>8
    db (CLK/523)>>8
    db (CLK/523)>>8
    db (CLK/523)>>8
    db (CLK/523)>>8
    db (CLK/523)>>8
    db (CLK/523)>>8
    db (CLK/523)>>8
    db (CLK/523)>>8
    db (CLK/523)>>8
    db (CLK/523)>>8
    db 255

strStats
	db "SCORE:000000  BEST:000000  LEVEL:00  DONE:000%  LIVES:0",0
strAreaClear
	db "CLR",0
strAreaClearSpace
	db "   ",0
strTitle
	db " ###        ##    ##  ###",0
	db "##    ####      #### ##     ###   #### ####",0
	db "##    ## ## ## ## ##  ###  ## ## ## ## ## ##",0
	db "## ## ##    ## ## ##    ## ##    ## ## ## ##",0
	db "## ## ##    ## ## ## ## ## ## ## ## ## ## ##",0
	db "##### ##    ## ##### ##### ##### ##### ## ##",0
	db "##### ##    ## ##### ##### ##### ##### ## ##",0
 	db " ###  ##    ##  ####  ###   ###   #### ## ##",0
strTitleStart
	db "PRESS ANY KEY TO START",0
strTitleBy
	db "PD 2010 SHIRU",0
strLevel
	db "L E V E L",0
strGameOver
	db "G A M E  O V E R",0
strComplete1
	db "WELL DONE! YOU HAVE CLEARED ALL THE LEVELS!",0
strComplete2
	db "NOW YOU CAN CONTINUE THE GAME TO GET THE BEST SCORE",0
strSound
	db 10,"ENABLE VI53 SOUND? (Y/N)",0

levelList
	dw level1,level2,level3,level4,level5,level6,level7,level8,level9,level10

level1
	dw 12*78+29	;map offset
	db 1,2		;size
	db 6		;enemy speed
	db 0		;end of level data

level2
	dw 8*78+29	;map offset
	db 2,2		;size
	db 5		;enemy speed
	db 0		;end of level data

level3
	dw 8*78+29	;map offset
	db 2,2		;size
	db 6		;enemy speed
	db 7
	db 0		;end of level data

level4
	dw 8*78+24	;map offset
	db 2,3		;size
	db 5		;enemy speed
	db 0		;end of level data

level5
	dw 6*78+24	;map offset
	db 3,3		;size
	db 5		;enemy speed
	db 6
	db 0		;end of level data

level6
	dw 6*78+20	;map offset
	db 3,4		;size
	db 5		;enemy speed
	db 5
	db 7
	db 0		;end of level data

level7
	dw 6*78+17	;map offset
	db 3,5		;size
	db 5		;enemy speed
	db 5
	db 5
	db 0		;end of level data

level8
	dw 6*78+14	;map offset
	db 3,6		;size
	db 5		;enemy speed
	db 5
	db 5
	db 4
	db 0		;end of level data

level9
	dw 3*78+14	;map offset
	db 4,6		;size
	db 5		;enemy speed
	db 5
	db 4
	db 4
	db 0		;end of level data

level10
	dw 3*78+9	;map offset
	db 4,7		;size
	db 5		;enemy speed
	db 5
	db 4
	db 4
	db 3
	db 0		;end of level data

end

	;display /d,end-begin

map			ds 78*30
mapc		ds 78*30
areaCnt		ds 7*4
areaCntChk	ds 7*4
areaOff		ds 7*4*2
areaFract	dw 0
areaLevel	db 0
playerPos	dw 0
playerDir	dw 0
score		dw 0
level		db 0
lives		db 0
topScore	dw 0
levelDone	dw 0
frameCnt	db 0
invisible	db 0
stunCnt		db 0
enemyList	ds 7*16
enemyCnt	db 0
enemyFrame	db 0
mapWidth	db 0
mapHeight	db 0
soundPtr	dw 0
soundDiv	dw 0
soundCnt	db 0
sound		db 0

	;display /d,$

	savebin "game.bin",begin,end-begin